#!/bin/sh

# Copyright (c) 2006, TeamF1, Inc.
#

# Modification History
# -------------------
# 01a,25feb06,sam derived from other scripts. 

setupenv( )
{
    if [ -z $TGT_OS ]; then
        export TGT_OS=linux
    fi

    if [ -z $CPU ]; then
        export CPU=i386
    fi
     
    if [ -z $TOOL ]; then
        export TOOL=586-
    fi
     
    EXIT=0;
    if [ -z $KERNELPATH ]; then
    while [ $EXIT = 0 ]
    do
        echo "Enter the path of the kernel source: ";
        read KERNELPATH;

        if [ $KERNELPATH ]; then
            if [ -d $KERNELPATH ]; then
                EXIT=1
            else
                echo "Directory does not exist. Please enter again: ";
            fi
        fi;
    done

    fi

    BASE_DIR=`pwd`
    if [ -z $PLATFORM_BASE ]; then
        export PLATFORM_BASE=$BASE_DIR
    fi
}

patchkernel( )
{
    PATCHFILES=`cd $GPL_BASE/iptables-1.3.4/linux-2.6.16/; 
                find -type f | sed '/svn/d'`;

    for i in $PATCHFILES
    do
        [ `basename $i` != "configure.sh" ] &&
            { 
            cmp -s $GPL_BASE/iptables-1.3.4/linux-2.6.16/$i $KERNELPATH/$i;
            if [ $? -gt 0 ]; then
                echo "Patching file: $KERNELPATH/$i";
                cp -b --suffix=.orig --reply=yes \
                   $GPL_BASE/iptables-1.3.4/linux-2.6.16/$i $KERNELPATH/$i;
            fi
            }
    done
    return 0;
}

patchkernel_fvs336gv2( )
{
    PATCHFILES=`cd $GPL_BASE/iptables-1.3.4/linux-2.6.16-fvs336gv2/; 
                find -type f | sed '/svn/d'`;

    for i in $PATCHFILES
    do
        [ `basename $i` != "configure.sh" ] &&
            { 
            cmp -s $GPL_BASE/iptables-1.3.4/linux-2.6.16-fvs336gv2/$i $KERNELPATH/$i;
            if [ $? -gt 0 ]; then
                echo "Patching file FVS336Gv2: $KERNELPATH/$i";
                cp -b --suffix=.orig --reply=yes \
                   $GPL_BASE/iptables-1.3.4/linux-2.6.16-fvs336gv2/$i $KERNELPATH/$i;
            fi
            }
    done
    return 0;
}

setupenv;
patchkernel;
if [ $TGT_BOARD == "ngfvs336gv2" ]; then
    echo "Patching FVS336Gv2 specific files"
    patchkernel_fvs336gv2;
fi
